;
; Ficheiro: TestBox.asm
;
;-----------------------------------------------------------------------------------------------
;
.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc

      include \masm32\include\masm32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc

      include \masm32\include\dialogs.inc

;...................................
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib

      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

WinMain     proto :DWORD,:DWORD,:DWORD,:DWORD
DlgQtm      proto :DWORD, :DWORD, :DWORD, :DWORD

;--------------------------------------------------------
.data
ClassName db "SimpleWinClass",0
AppName   db "Test Window",0
MenuName  db "FirstMenu",0

_PtrCaseChoose      dd 0

                    dd 3
                    dd 1
_NewQtmMin          db "5  "
                    db 0                                                         
;-------------------------------------------------------------
.data?
_hInstance HINSTANCE ?
CommandLine LPSTR ?

_icce       INITCOMMONCONTROLSEX <?>            ; estrutura para as janelas
; 
.const
IDM_EXIT   equ 1
IDM_ABOUT  equ 2

IDC_NEWQTM1      equ 15140
IDC_NEWQTM2      equ 15150
IDC_NEWQTM3      equ 15160

.code
start:
	invoke GetModuleHandle, NULL
	mov    _hInstance,eax
;
	invoke GetCommandLine
	invoke WinMain, _hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
; ----------------------------------------------------------------------------------------------

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,OFFSET MenuName
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax

	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,300,200,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
;...............................................................................
    mov     _icce.dwSize, SIZEOF INITCOMMONCONTROLSEX
    mov     _icce.dwICC, ICC_DATE_CLASSES or ICC_INTERNET_CLASSES or \
                         ICC_PAGESCROLLER_CLASS or ICC_COOL_CLASSES

    invoke  InitCommonControlsEx, ADDR _icce
;...............................................................................
	INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax, msg.wParam
	ret
WinMain endp
; 
WndProc         proc    hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
                mov     eax, uMsg
                cmp     eax, WM_DESTROY
                jne     _WM_COMMANDw
                ;
		    invoke PostQuitMessage, NULL
                jmp   _endWP
            
_WM_COMMANDw:   cmp     eax, WM_COMMAND
                jne     _eWndProc
                ;
		    mov     eax,wParam
		    cmp     ax, IDM_ABOUT
                jne     _WM_COMMANDd
                ;
                ;
                ;
;************************************************************************************
;ALTERAMIN   macro
    invoke  InitCommonControlsEx, ADDR _icce

    Dialog "Quantidade ","MS Sans Serif", 10,\              ; caption,font,pointsize
            WS_OVERLAPPED or DS_CENTER, \                   ; style
            5, \                                            ; control count
            5,5,200,90, \                                   ; x y co-ordinates
            512                                             ; memory buffer size
    DlgButton "  ALTERA  ",WS_TABSTOP,    110, 40, 55, 10, IDC_NEWQTM2
    DlgButton "  ACTUALIZA  ", WS_TABSTOP, 30, 40, 55, 10, IDCANCEL
    DlgButton "  CANCELA ",WS_TABSTOP,     70, 56, 55, 10, IDC_NEWQTM3

    DlgStatic "Novo valor:",0,              56, 18,  40, 9, 100
    DlgEdit WS_TABSTOP or WS_EX_CLIENTEDGE or WS_EX_STATICEDGE , 98, 18,  12, 8, IDC_NEWQTM1
    CallModalDialog     _hInstance, 0, DlgQtm, NULL
; ENDM
;************************************************************************************
                jmp   _endWP      
                ;
_WM_COMMANDd:   invoke DestroyWindow, hWnd
                jmp   _endWP
;................................................................
_eWndProc:      invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		    ret
;................................................................
_endWP:         xor    eax,eax
	          ret
WndProc         endp
; 
DlgQtm          PROC    hWnd:DWORD, iMsg:DWORD, wParam:DWORD, lParam:DWORD
                mov     eax, iMsg
                ;
                cmp     eax, WM_INITDIALOG
                jne     _CloseDlgQtm
                ;
                mov      dword ptr _PtrCaseChoose, 1                
                ;                
_iniDlgQtm:     mov      edi, offset _NewQtmMin
                ;call     CvRclDos
		    invoke   SetDlgItemText, hWnd, IDC_NEWQTM1, edi
                ;
                invoke   GetDlgItem, hWnd, IDC_NEWQTM2      
		    invoke   SetFocus, eax
                jmp     _exitDlgQtm
;.............................................................            
_CloseDlgQtm:   cmp     eax, WM_CLOSE
                jne     _CmdDlgQtm
                
_QuitDlgQtm:    invoke   EndDialog, hWnd, NULL
                jmp      _exitDlgQtm
;.............................................................
_CmdDlgQtm:     cmp     eax, WM_COMMAND
                jne     _endDlgQtm
                ;
                mov     eax, wParam
;.........................................................................
                        
;.........................................................................                
_cancelDlgQtm:  cmp     eax, IDCANCEL
                je       _QuitDlgQtm
                ;
                cmp     eax, IDC_NEWQTM2
                jne     _IDC_NEWQTM3
                ;
                ; Get strings
                ; ***********
		    invoke   GetDlgItemText, hWnd, IDC_NEWQTM1, addr _NewQtmMin, 4
                ;
                mov      esi, offset _NewQtmMin
                ;call     CvDosRcl
                jmp      _iniDlgQtm
                ;
_IDC_NEWQTM3:   cmp     eax, IDC_NEWQTM3
                jne     _exitDlgQtm
                ;
                mov      dword ptr _PtrCaseChoose, 0
                jmp      _QuitDlgQtm
;...........................................
_exitDlgQtm:    mov  eax,TRUE
	          ret
;...................................................
_endDlgQtm:     mov eax, FALSE
		    ret
;======================================================            
DlgQtm          endp
; 

; 
end start
